﻿using NAudio.Wave;

namespace TestLibrary
{
    /// <summary>
    /// 피크 공급자 인터페이스
    /// </summary>
    public interface IPeakProvider
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method

        #region 초기화하기 - Initialize(provider, sampleCountPerPixel)

        /// <summary>
        /// 초기화하기
        /// </summary>
        /// <param name="provider">샘플 공급자 인터페이스</param>
        /// <param name="sampleCountPerPixel">픽셀당 샘플 수</param>
        void Initialize(ISampleProvider provider, int sampleCountPerPixel);

        #endregion
        #region 다음 피크 정보 구하기 - GetNextPeakInfo()

        /// <summary>
        /// 다음 피크 정보 구하기
        /// </summary>
        /// <returns>다음 피크 정보</returns>
        PeakInfo GetNextPeakInfo();

        #endregion
    }
}