﻿using System.Linq;

namespace TestLibrary
{
    /// <summary>
    /// 최대 피크 공급자
    /// </summary>
    public class MaximumPeakProvider : PeakProvider
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 다음 피크 정보 구하기 - GetNextPeakInfo()

        /// <summary>
        /// 다음 피크 정보 구하기
        /// </summary>
        /// <returns>다음 피크 정보</returns>
        public override PeakInfo GetNextPeakInfo()
        {
            int sampleCountRead = Provider.Read(ReadBuffer,0,ReadBuffer.Length);

            float maximum = (sampleCountRead == 0) ? 0 : ReadBuffer.Take(sampleCountRead).Max();
            float minimum = (sampleCountRead == 0) ? 0 : ReadBuffer.Take(sampleCountRead).Min();

            return new PeakInfo(minimum, maximum);
        }

        #endregion
    }
}