using System.Drawing;

namespace TestLibrary
{
    /// <summary>
    ///  Ŭ  ̺  
    /// </summary>
    public class SoundCloudBlockWaveFormSetting : WaveFormRendererSetting
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        ///    
        /// </summary>
        private readonly Color topSpacerStartColor;

        /// <summary>
        ///  
        /// </summary>
        private Pen topPen;

        /// <summary>
        ///   
        /// </summary>
        private Pen topSpacerPen;

        /// <summary>
        /// ϴ 
        /// </summary>
        private Pen bottomPen;

        /// <summary>
        /// ϴ  
        /// </summary>
        private Pen bottomSpacerPen;

        /// <summary>
        /// ֱ  
        /// </summary>
        private int lastTopHeight;

        /// <summary>
        /// ֱ ϴ 
        /// </summary>
        private int lastBottomHeight;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ũ  - TopPeakPen

        /// <summary>
        ///  ũ 
        /// </summary>
        public override Pen TopPeakPen
        {
            get
            {
                return this.topPen;
            }
            set
            {
                this.topPen = value;
            }
        }

        #endregion
        #region   ׶Ʈ   - TopSpacerGradientStartColor

        /// <summary>
        ///   ׶Ʈ  
        /// </summary>
        public Color TopSpacerGradientStartColor { get; set; }

        #endregion
        #region    - TopSpacerPen

        /// <summary>
        ///   
        /// </summary>
        public override Pen TopSpacerPen
        {
            get
            {
                if(this.topSpacerPen == null || this.lastBottomHeight != BottomHeight || this.lastTopHeight != TopHeight)
                {
                    this.topSpacerPen = CreateGradientPen(TopHeight, TopSpacerGradientStartColor, this.topSpacerStartColor);

                    this.lastTopHeight    = TopHeight;
                    this.lastBottomHeight = BottomHeight;
                }

                return topSpacerPen;
            }
            set
            {
                this.topSpacerPen = value;
            }
        }

        #endregion
        #region ϴ ũ  - BottomPeakPen

        /// <summary>
        /// ϴ ũ 
        /// </summary>
        public override Pen BottomPeakPen
        {
            get
            {
                return bottomPen;
            }
            set
            {
                bottomPen = value;
            }
        }

        #endregion
        #region ϴ   - BottomSpacerPen

        /// <summary>
        /// ϴ  
        /// </summary>
        public override Pen BottomSpacerPen
        {
            get
            {
                return this.bottomSpacerPen;
            }
            set
            {
                this.bottomSpacerPen = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - SoundCloudBlockWaveFormSetting(topPeakColor, topSpacerStartColor, bottomPeakColor, bottomSpacerColor)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="topPeakColor"> ũ </param>
        /// <param name="topSpacerStartColor">   </param>
        /// <param name="bottomPeakColor">ϴ ũ </param>
        /// <param name="bottomSpacerColor">ϴ  </param>
        public SoundCloudBlockWaveFormSetting(Color topPeakColor, Color topSpacerStartColor, Color bottomPeakColor, Color bottomSpacerColor)
        {
            this.topPen              = new Pen(topPeakColor);
            this.topSpacerStartColor = topSpacerStartColor;
            this.bottomPen           = new Pen(bottomPeakColor);
            this.bottomSpacerPen     = new Pen(bottomSpacerColor);

            PixelCountPerPeak           = 4;
            SpacerPixelCount            = 2;
            BackgroundColor             = Color.White;
            TopSpacerGradientStartColor = Color.White;
        }

        #endregion
    }
}