using System.Drawing;
using System.Drawing.Drawing2D;

namespace TestLibrary
{
    /// <summary>
    /// ̺   
    /// </summary>
    public class WaveFormRendererSetting
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ī - Name

        /// <summary>
        /// Ī
        /// </summary>
        public string Name { get; set; }

        #endregion
        #region ʺ - Width

        /// <summary>
        /// ʺ
        /// </summary>
        public int Width { get; set; }

        #endregion
        #region   - TopHeight

        /// <summary>
        ///  
        /// </summary>
        public int TopHeight { get; set; }

        #endregion
        #region ϴ  - BottomHeight

        /// <summary>
        /// ϴ 
        /// </summary>
        public int BottomHeight { get; set; }

        #endregion
        #region ũ ȼ  - PixelCountPerPeak

        /// <summary>
        /// ũ ȼ 
        /// </summary>
        public int PixelCountPerPeak { get; set; }

        #endregion
        #region  ȼ  - SpacerPixelCount

        /// <summary>
        ///  ȼ 
        /// </summary>
        public int SpacerPixelCount { get; set; }

        #endregion
        #region  ũ  - TopPeakPen

        /// <summary>
        ///  ũ 
        /// </summary>
        public virtual Pen TopPeakPen { get; set; }

        #endregion
        #region    - TopSpacerPen

        /// <summary>
        ///   
        /// </summary>
        public virtual Pen TopSpacerPen { get; set; }

        #endregion
        #region ϴ ũ  - BottomPeakPen

        /// <summary>
        /// ϴ ũ 
        /// </summary>
        public virtual Pen BottomPeakPen { get; set; }

        #endregion
        #region ϴ   - BottomSpacerPen

        /// <summary>
        /// ϴ  
        /// </summary>
        public virtual Pen BottomSpacerPen { get; set; }

        #endregion
        #region ú  - DecibelScale

        /// <summary>
        /// ú 
        /// </summary>
        public bool DecibelScale { get; set; }

        #endregion
        #region   - BackgroundColor

        /// <summary>
        ///  
        /// </summary>
        public Color BackgroundColor { get; set; }

        #endregion
        #region  ̹ - BackgroundImage

        /// <summary>
        ///  ̹
        /// </summary>
        public Image BackgroundImage { get; set; }

        #endregion
        #region  귯 - BackgroundBrush

        /// <summary>
        ///  귯
        /// </summary>
        public Brush BackgroundBrush
        {
            get
            {
                if(BackgroundImage == null)
                {
                    return new SolidBrush(BackgroundColor);
                }

                return new TextureBrush(BackgroundImage, WrapMode.Clamp);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region  - WaveFormRendererSetting()

        /// <summary>
        /// 
        /// </summary>
        protected WaveFormRendererSetting()
        {
            Width             = 800;
            TopHeight         = 50;
            BottomHeight      = 50;
            PixelCountPerPeak = 1;
            SpacerPixelCount  = 0;
            BackgroundColor   = Color.Beige;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region ׶Ʈ  ϱ - CreateGradientPen(height, startColor, endColor)

        /// <summary>
        /// ׶Ʈ  ϱ
        /// </summary>
        /// <param name="height"></param>
        /// <param name="startColor"> </param>
        /// <param name="endColor"> </param>
        /// <returns>׶Ʈ </returns>
        protected static Pen CreateGradientPen(int height, Color startColor, Color endColor)
        {
            LinearGradientBrush brush = new LinearGradientBrush(new Point(0, 0), new Point(0, height), startColor, endColor);

            return new Pen(brush);
        }


        #endregion
    }
}